<SCRIPT LANGUAGE="VBScript" RUNAT="Server">
' Class EnhancedFormClass written by Christoph Wille
' Based on code from http://www.pstruh.cz/tips/detpg_largepost.htm by
' Antonin Foller, PSTRUH Software, http://www.pstruh.cz

Class EnhancedFormClass
 Public Function GetFormCollection()
  Dim FormFields	' Dictionary which will store source fields.
  Set FormFields = Server.CreateObject("Scripting.Dictionary")

  'If there are some POST source data
  If Request.TotalBytes > 0 And _
  		Request.ServerVariables("HTTP_CONTENT_TYPE") = "application/x-www-form-urlencoded" Then
    Dim SourceData
    SourceData = Request.BinaryRead(Request.TotalBytes)
    SourceData = RSBinaryToString(SourceData)	' Convert source binary data to a string

    SourceData = Split(SourceData, "&")	' Form fields are separated by "&"
    Dim Field, FieldName, FieldContents
  
    For Each Field In SourceData
      Field = Split(Field, "=")	' Field name and contents is separated by "="
      FieldName = DecodeUrlData(Field(0))
      FieldContents = DecodeUrlData(Field(1))
      FormFields.Add FieldName, FieldContents	' Add field to the dictionary
    Next
  End If	' Request.Totalbytes > 0
  Set GetFormCollection = FormFields
 End Function
 
 Private Function DecodeUrlData(ByVal What)
  Dim Pos, pPos
  What = Replace(What, "+", " ")	' replace + to space

  On Error Resume Next
  Dim Stream
  Set Stream = Server.CreateObject("ADODB.Stream")
  If 0 = Err.Number Then ' decode URL data using ADODB.Stream, If possible
    On Error GoTo 0
    Stream.Type = 2 'String
    Stream.Open

    Pos = InStr(1, What, "%")	' replace all %XX to character
    pPos = 1
    Do While Pos > 0
      Stream.WriteText Mid(What, pPos, Pos - pPos) + _
        Chr(CLng("&H" & Mid(What, Pos + 1, 2)))
      pPos = Pos + 3
      Pos = InStr(pPos, What, "%")
    Loop
    Stream.WriteText Mid(What, pPos)

    Stream.Position = 0	' read the text stream
    DecodeUrlData = Stream.ReadText
    Stream.Close	' free resources
  Else ' URL decode using string concentation
    On Error GoTo 0
    ' Slow, do not use it for data length over 100k
    Pos = InStr(1, What, "%")
    Do While Pos>0 
      What = Left(What, Pos-1) + _
        Chr(Clng("&H" & Mid(What, Pos+1, 2))) + _
        Mid(What, Pos+3)
      Pos = InStr(Pos+1, What, "%")
    Loop
    DecodeUrlData = What
  End If
 End Function
 
 Private Function RSBinaryToString(Binary)
  Dim RS, LBinary
  Const adLongVarChar = 201
  Set RS = Server.CreateObject("ADODB.Recordset")
  LBinary = LenB(Binary)
  
  If LBinary>0 Then
    RS.Fields.Append "mBinary", adLongVarChar, LBinary
    RS.Open
    RS.AddNew
      RS("mBinary").AppendChunk Binary 
    RS.Update
    RSBinaryToString = RS("mBinary")
  Else
    RSBinaryToString = ""
  End If
 End Function
End Class
</SCRIPT>